from __future__ import division
import es, wcs, gamethread, random, playerlib
from wcs import wcs
info = es.AddonInfo() 
info['name']        = "HackJack"
info['version']     = "1.0"
info['author']      = "||7DS||Wolf||"
info['url']         = ""
info['description'] = "HackJack by ||7DS||Wolf||"
''' '''
Name = 'HackJack'
wcs.Race(Name).registerSkill('Dual Elites',1,1,'You take your best weapons for battle.')
wcs.Race(Name).registerSkill('Rebound Theory',5,1,'Damage to your armor hurts your enemies.')
wcs.Race(Name).registerSkill('Thunder Clap',5,1,'Press +Ability to paralyze/shake nearby enemies')
wcs.Race(Name).registerSkill('Blown Away',5,1,'Press +Ability2 to push nearby enemies back.')
wcs.Race(Name).registerUltimate('Drop Zone',10,5,1,'Press +Ultimate to force your enemies to drop their weapons.')
wcs.Race(Name).registerWeaponRestriction('allow only', ('knife','elite'))


es.ServerVar('HackJackVersion',info.version,'Current HackJack Version').makepublic()

def player_spawn(ev):
	userid = int(ev['userid'])
	de = wcs.GetLevel(userid, Name, 'Dual Elites')
	if wcs.GetRace(userid) == 'HackJack':
		wcs.Command(userid).SetGravity(.8)
		wcs.Command(userid).Health(300)
		wcs.Command(userid).Armor(500)
		es.server.cmd('est_RemoveWeapon %s %s'%(userid, 1))
		es.server.cmd('est_RemoveWeapon %s %s'%(userid, 4))
		if de:
			es.server.queuecmd('est_Give %s weapon_elite'%userid)
			es.tell(userid,'#multi','#greenDual Elites #default- #lightgreenYou have taken your \'#greenDual Elites#lightgreen\' into battle.')
def prep_hurt(ev):
	userid = int(ev['userid'])
	attacker = int(ev['attacker'])
	if attacker:
		life = int(ev['dmg_health'])
		rt = wcs.GetLevel(userid, Name, 'Rebound Theory') 
		if rt:
			if playerlib.getPlayer(userid).get('armor') <= 500:
				wcs.Command(attacker).Damage(life*.3,32,userid)
				es.tell(userid, '#multi', '#lightgreenRebound Theory #default- #lightgreenYour \'#greenRebound Theory #lightgreen\' has hurt #green%s.'%es.getplayername(attacker))
				es.tell(attacker, '#multi', '#lightgreenRebound Theory #default- #lightgreenYou have been hurt by #green%s\'s #lightgreen\'#greenRebound Theory #lightgreen\'.'%es.getplayername(userid))
			
def player_ability_on(ev):
	userid = int(ev['userid'])
	tc = wcs.GetLevel(userid, Name, 'Thunder Clap')
	team = int(es.getplayerteam(userid))
	if team == 2:
		filter = '#ct'
	elif team == 3:
		filter = '#t'
	if wcs.GetRace(userid) == 'HackJack':
		if tc:
			if not wcs.Command(userid).GetCoolDown('Thunder Clap'):
				wcs.Command(userid).Near(tc*100,clap,filter)
				wcs.Command(userid).SetCoolDown('Thunder Clap',tc*2)
				wcs.Effect().Ring1(userid, tc*100, 2, 244, 164, 96)
				es.tell(userid, '#multi', '#lightgreenThunder Clap #default- #greenYou have paralyzed nearby enemies.')
def clap(userid, attacker):
	wcs.Command(userid).Freeze(wcs.GetLevel(attacker, Name, 'Thunder Clap')*.5)
	wcs.Command(userid).Shake(wcs.GetLevel(attacker, Name, 'Thunder Clap')*.5, 5)
	es.tell(userid, '#multi', '#lightgreenThunder Clap #default- #greenYou have been paralyzed by #lightgreen%s\'s \'#greenThunder Clap#lightgreen\'.'%es.getplayername(attacker))

def player_ability_on2(ev):
	userid = int(ev['userid'])
	team = int(ev['es_userteam'])
	ba = wcs.GetLevel(userid, Name, 'Blown Away')
	if wcs.GetRace(userid) == 'HackJack':
		if ba:
			filt = '#ct'
			if team == 3:
				filt = '#t'
		wcs.Command(userid).UpdateDict('push loop', 1)
		es.tell(userid, '#multi', '#greenBlown Away #default- #lightgreenActivated.')
		push_loop(userid, filt)
def push_loop(userid, filt):
	if wcs.Command(userid).ReturnDict('push loop'):
		wcs.Effect().Misc3(userid, 1, 6)
		wcs.Command(userid).Freeze(1)
		wcs.Command(userid).Near(wcs.GetLevel(userid, Name, 'Blown Away')*25,push_target,filt)
		gamethread.delayed(1, push_loop, (userid, filt))
def push_target(userid, attacker):
    #These values u should adjust to your liking
	wcs.Command(userid).Push(10000, 10000, 10000)
	es.tell(userid, '#multi', '#greenBlown Away #default- #lightgreenYou have been \'#greenBlown Away#lightgreen\'.')
	es.tell(attacker, '#multi', '#greenBlown Away #default- #lightgreenYou have \'#greenBlown Away#lightgreen\' %s.'%es.getplayername(userid))
def player_ability_off2(ev):
	userid = int(ev['userid'])
	if wcs.Command(userid).ReturnDict('push loop'):
		wcs.Command(userid).UpdateDict('push loop', 0)
		es.tell(userid, '#multi', '#greenBlown Away #default- #lightgreenDeactivated.')		

def player_ultimate_on(ev):
	userid = int(ev['userid'])
	dz = wcs.GetLevel(userid, Name, 'Drop Zone')
	team = int(es.getplayerteam(userid))
	if team == 2:
		filter = '#ct'
	elif team == 3:
		filter = '#t'
	if wcs.GetRace(userid) == 'HackJack':
		if dz:
			wcs.Command(userid).Near(dz*100,drop,filter)
			wcs.Command(userid).SetCoolDown('Drop Zone',dz*2)
			wcs.Effect().Ring1(userid, dz*100, 2, 244, 164, 96)
			es.tell(userid, '#multi', '#lightgreenDrop Zone #default- #greenYou have forced the enemies around to drop their weapons.')
def drop(userid, attacker):
	wcs.Command(userid).Drop()
	es.tell(userid, '#multi', '#lightgreenDrop Zone #default- #greenYour weapon has been pulled from your hands.')

		
